SDL_test_md5.c File Reference
`#include "SDL_config.h"`
`#include "SDL_test.h"`
Include dependency graph for SDL_test_md5.c:

Go to the source code of this file.

## Macros

#define | F(x, y, z) (((x) & (y)) | ((~x) & (z)))
#define | G(x, y, z) (((x) & (z)) | ((y) & (~z)))
#define | H(x, y, z) ((x) ^ (y) ^ (z))
#define | I(x, y, z) ((y) ^ ((x) | (~z)))
#define | ROTATE_LEFT(x, n) (((x) << (n)) | ((x) >> (32-(n))))
#define | FF(a, b, c, d, x, s, ac)
#define | GG(a, b, c, d, x, s, ac)
#define | HH(a, b, c, d, x, s, ac)
#define | II(a, b, c, d, x, s, ac)
#define | S11 7
#define | S12 12
#define | S13 17
#define | S14 22
#define | S21 5
#define | S22 9
#define | S23 14
#define | S24 20
#define | S31 4
#define | S32 11
#define | S33 16
#define | S34 23
#define | S41 6
#define | S42 10
#define | S43 15
#define | S44 21

## Functions

static void | SDLTest_Md5Transform (MD5UINT4 *buf, MD5UINT4 *in)
void | SDLTest_Md5Init (SDLTest_Md5Context *mdContext)
| initialize the context More...
void | SDLTest_Md5Update (SDLTest_Md5Context *mdContext, unsigned char *inBuf, unsigned int inLen)
| update digest from variable length data More...
void | SDLTest_Md5Final (SDLTest_Md5Context *mdContext)
| complete digest computation More...

## Variables

static unsigned char | MD5PADDING [64]

## Macro Definition Documentation

## F

#define F | ( |  | x,
|  |  | y,
|  |  | z
| ) |  | (((x) & (y)) | ((~x) & (z)))

Definition at line 73 of file SDL_test_md5.c.

Referenced by SDL_MixAudioFormat().

## FF

#define FF | ( |  | a,
|  |  | b,
|  |  | c,
|  |  | d,
|  |  | x,
|  |  | s,
|  |  | ac
| ) |  |

Value:
{(a) += F ((b), (c), (d)) + (x) + (MD5UINT4)(ac); \
(a) = ROTATE_LEFT ((a), (s)); \
(a) += (b); \
}
s
GLdouble s
Definition: SDL_opengl.h:2063
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
ROTATE_LEFT
#define ROTATE_LEFT(x, n)
Definition: SDL_test_md5.c:79
d
SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char const char SDL_SCANF_FORMAT_STRING const char return SDL_ThreadFunction const char void return Uint32 return Uint32 SDL_AssertionHandler void SDL_SpinLock SDL_atomic_t int int return SDL_atomic_t return void void void return void return int return SDL_AudioSpec SDL_AudioSpec return int int return return int SDL_RWops int SDL_AudioSpec Uint8 ** d
Definition: SDL_dynapi_procs.h:117
c
const GLubyte * c
Definition: SDL_opengl_glext.h:11093
MD5UINT4
unsigned long int MD5UINT4
Definition: SDL_test_md5.h:68
F
#define F(x, y, z)
Definition: SDL_test_md5.c:73
a
GLboolean GLboolean GLboolean GLboolean a
Definition: SDL_opengl_glext.h:1109
b
GLboolean GLboolean GLboolean b
Definition: SDL_opengl_glext.h:1109

Definition at line 84 of file SDL_test_md5.c.

Referenced by SDLTest_Md5Transform().

## G

#define G | ( |  | x,
|  |  | y,
|  |  | z
| ) |  | (((x) & (z)) | ((y) & (~z)))

Definition at line 74 of file SDL_test_md5.c.

Referenced by Map1toN(), RGBtoYUV(), SDL_Blit_ABGR8888_ARGB8888_Modulate(), SDL_Blit_ABGR8888_ARGB8888_Modulate_Scale(), SDL_Blit_ABGR8888_ARGB8888_Scale(), SDL_Blit_ABGR8888_BGR888_Modulate(), SDL_Blit_ABGR8888_BGR888_Modulate_Scale(), SDL_Blit_ABGR8888_BGR888_Scale(), SDL_Blit_ABGR8888_RGB888_Modulate(), SDL_Blit_ABGR8888_RGB888_Modulate_Scale(), SDL_Blit_ABGR8888_RGB888_Scale(), SDL_Blit_ARGB8888_ARGB8888_Modulate(), SDL_Blit_ARGB8888_ARGB8888_Modulate_Scale(), SDL_Blit_ARGB8888_BGR888_Modulate(), SDL_Blit_ARGB8888_BGR888_Modulate_Scale(), SDL_Blit_ARGB8888_BGR888_Scale(), SDL_Blit_ARGB8888_RGB888_Modulate(), SDL_Blit_ARGB8888_RGB888_Modulate_Scale(), SDL_Blit_ARGB8888_RGB888_Scale(), SDL_Blit_BGR888_ARGB8888_Modulate(), SDL_Blit_BGR888_ARGB8888_Modulate_Scale(), SDL_Blit_BGR888_ARGB8888_Scale(), SDL_Blit_BGR888_BGR888_Modulate(), SDL_Blit_BGR888_BGR888_Modulate_Scale(), SDL_Blit_BGR888_RGB888_Modulate(), SDL_Blit_BGR888_RGB888_Modulate_Scale(), SDL_Blit_BGR888_RGB888_Scale(), SDL_Blit_BGRA8888_ARGB8888_Modulate(), SDL_Blit_BGRA8888_ARGB8888_Modulate_Scale(), SDL_Blit_BGRA8888_ARGB8888_Scale(), SDL_Blit_BGRA8888_BGR888_Modulate(), SDL_Blit_BGRA8888_BGR888_Modulate_Scale(), SDL_Blit_BGRA8888_BGR888_Scale(), SDL_Blit_BGRA8888_RGB888_Modulate(), SDL_Blit_BGRA8888_RGB888_Modulate_Scale(), SDL_Blit_BGRA8888_RGB888_Scale(), SDL_Blit_RGB888_ARGB8888_Modulate(), SDL_Blit_RGB888_ARGB8888_Modulate_Scale(), SDL_Blit_RGB888_ARGB8888_Scale(), SDL_Blit_RGB888_BGR888_Modulate(), SDL_Blit_RGB888_BGR888_Modulate_Scale(), SDL_Blit_RGB888_BGR888_Scale(), SDL_Blit_RGB888_RGB888_Modulate(), SDL_Blit_RGB888_RGB888_Modulate_Scale(), SDL_Blit_RGBA8888_ARGB8888_Modulate(), SDL_Blit_RGBA8888_ARGB8888_Modulate_Scale(), SDL_Blit_RGBA8888_ARGB8888_Scale(), SDL_Blit_RGBA8888_BGR888_Modulate(), SDL_Blit_RGBA8888_BGR888_Modulate_Scale(), SDL_Blit_RGBA8888_BGR888_Scale(), SDL_Blit_RGBA8888_RGB888_Modulate(), SDL_Blit_RGBA8888_RGB888_Modulate_Scale(), SDL_Blit_RGBA8888_RGB888_Scale(), SDL_ConvertPixels_ARGB8888_to_YUV(), and SDLTest_CompareSurfaces().

## GG

#define GG | ( |  | a,
|  |  | b,
|  |  | c,
|  |  | d,
|  |  | x,
|  |  | s,
|  |  | ac
| ) |  |

Value:
{(a) += G ((b), (c), (d)) + (x) + (MD5UINT4)(ac); \
(a) = ROTATE_LEFT ((a), (s)); \
(a) += (b); \
}
s
GLdouble s
Definition: SDL_opengl.h:2063
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
ROTATE_LEFT
#define ROTATE_LEFT(x, n)
Definition: SDL_test_md5.c:79
d
SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char const char SDL_SCANF_FORMAT_STRING const char return SDL_ThreadFunction const char void return Uint32 return Uint32 SDL_AssertionHandler void SDL_SpinLock SDL_atomic_t int int return SDL_atomic_t return void void void return void return int return SDL_AudioSpec SDL_AudioSpec return int int return return int SDL_RWops int SDL_AudioSpec Uint8 ** d
Definition: SDL_dynapi_procs.h:117
c
const GLubyte * c
Definition: SDL_opengl_glext.h:11093
MD5UINT4
unsigned long int MD5UINT4
Definition: SDL_test_md5.h:68
G
#define G(x, y, z)
Definition: SDL_test_md5.c:74
a
GLboolean GLboolean GLboolean GLboolean a
Definition: SDL_opengl_glext.h:1109
b
GLboolean GLboolean GLboolean b
Definition: SDL_opengl_glext.h:1109

Definition at line 89 of file SDL_test_md5.c.

Referenced by SDLTest_Md5Transform().

## H

#define H | ( |  | x,
|  |  | y,
|  |  | z
| ) |  | ((x) ^ (y) ^ (z))

Definition at line 75 of file SDL_test_md5.c.

## HH

#define HH | ( |  | a,
|  |  | b,
|  |  | c,
|  |  | d,
|  |  | x,
|  |  | s,
|  |  | ac
| ) |  |

Value:
{(a) += H ((b), (c), (d)) + (x) + (MD5UINT4)(ac); \
(a) = ROTATE_LEFT ((a), (s)); \
(a) += (b); \
}
s
GLdouble s
Definition: SDL_opengl.h:2063
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
ROTATE_LEFT
#define ROTATE_LEFT(x, n)
Definition: SDL_test_md5.c:79
H
#define H(x, y, z)
Definition: SDL_test_md5.c:75
d
SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char const char SDL_SCANF_FORMAT_STRING const char return SDL_ThreadFunction const char void return Uint32 return Uint32 SDL_AssertionHandler void SDL_SpinLock SDL_atomic_t int int return SDL_atomic_t return void void void return void return int return SDL_AudioSpec SDL_AudioSpec return int int return return int SDL_RWops int SDL_AudioSpec Uint8 ** d
Definition: SDL_dynapi_procs.h:117
c
const GLubyte * c
Definition: SDL_opengl_glext.h:11093
MD5UINT4
unsigned long int MD5UINT4
Definition: SDL_test_md5.h:68
a
GLboolean GLboolean GLboolean GLboolean a
Definition: SDL_opengl_glext.h:1109
b
GLboolean GLboolean GLboolean b
Definition: SDL_opengl_glext.h:1109

Definition at line 94 of file SDL_test_md5.c.

Referenced by SDLTest_Md5Transform().

## I

#define I | ( |  | x,
|  |  | y,
|  |  | z
| ) |  | ((y) ^ ((x) | (~z)))

Definition at line 76 of file SDL_test_md5.c.

## II

#define II | ( |  | a,
|  |  | b,
|  |  | c,
|  |  | d,
|  |  | x,
|  |  | s,
|  |  | ac
| ) |  |

Value:
{(a) += I ((b), (c), (d)) + (x) + (MD5UINT4)(ac); \
(a) = ROTATE_LEFT ((a), (s)); \
(a) += (b); \
}
s
GLdouble s
Definition: SDL_opengl.h:2063
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
ROTATE_LEFT
#define ROTATE_LEFT(x, n)
Definition: SDL_test_md5.c:79
d
SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char const char SDL_SCANF_FORMAT_STRING const char return SDL_ThreadFunction const char void return Uint32 return Uint32 SDL_AssertionHandler void SDL_SpinLock SDL_atomic_t int int return SDL_atomic_t return void void void return void return int return SDL_AudioSpec SDL_AudioSpec return int int return return int SDL_RWops int SDL_AudioSpec Uint8 ** d
Definition: SDL_dynapi_procs.h:117
c
const GLubyte * c
Definition: SDL_opengl_glext.h:11093
I
#define I(x, y, z)
Definition: SDL_test_md5.c:76
MD5UINT4
unsigned long int MD5UINT4
Definition: SDL_test_md5.h:68
a
GLboolean GLboolean GLboolean GLboolean a
Definition: SDL_opengl_glext.h:1109
b
GLboolean GLboolean GLboolean b
Definition: SDL_opengl_glext.h:1109

Definition at line 99 of file SDL_test_md5.c.

Referenced by SDLTest_Md5Transform().

## ROTATE_LEFT

#define ROTATE_LEFT | ( |  | x,
|  |  | n
| ) |  | (((x) << (n)) | ((x) >> (32-(n))))

Definition at line 79 of file SDL_test_md5.c.

## S11

#define S11 7

Referenced by SDLTest_Md5Transform().

## S12

#define S12 12

Referenced by SDLTest_Md5Transform().

## S13

#define S13 17

Referenced by SDLTest_Md5Transform().

## S14

#define S14 22

Referenced by SDLTest_Md5Transform().

## S21

#define S21 5

Referenced by SDLTest_Md5Transform().

## S22

#define S22 9

Referenced by SDLTest_Md5Transform().

## S23

#define S23 14

Referenced by SDLTest_Md5Transform().

## S24

#define S24 20

Referenced by SDLTest_Md5Transform().

## S31

#define S31 4

Referenced by SDLTest_Md5Transform().

## S32

#define S32 11

Referenced by SDL_ParseAudioFormat(), and SDLTest_Md5Transform().

## S33

#define S33 16

Referenced by SDLTest_Md5Transform().

## S34

#define S34 23

Referenced by SDLTest_Md5Transform().

## S41

#define S41 6

Referenced by SDLTest_Md5Transform().

## S42

#define S42 10

Referenced by SDLTest_Md5Transform().

## S43

#define S43 15

Referenced by SDLTest_Md5Transform().

## S44

#define S44 21

Referenced by SDLTest_Md5Transform().

## Function Documentation

## SDLTest_Md5Final()

void SDLTest_Md5Final | ( | SDLTest_Md5Context * | mdContext | ) |

complete digest computation

Parameters

  mdContext | pointer to context variable

Note: The function terminates the message-digest computation and ends with the desired message digest in mdContext.digest[0..15]. Always call before using the digest[] variable.

Definition at line 180 of file SDL_test_md5.c.

References SDLTest_Md5Context::buf, SDLTest_Md5Context::digest, i, SDLTest_Md5Context::i, SDLTest_Md5Context::in, MD5PADDING, NULL, SDLTest_Md5Transform(), and SDLTest_Md5Update().

Referenced by SDLTest_GenerateExecKey().

{
MD5UINT4 in[16];
int mdi;
unsigned int i, ii;
unsigned int padLen;
if (mdContext == NULL) return;
/*
* save number of bits
*/
in[14] = mdContext->i[0];
in[15] = mdContext->i[1];
/*
* compute number of bytes mod 64
*/
mdi = (int) ((mdContext->i[0] >> 3) & 0x3F);
/*
* pad out to 56 mod 64
*/
padLen = (mdi < 56) ? (56 - mdi) : (120 - mdi);
SDLTest_Md5Update(mdContext, MD5PADDING, padLen);
/*
* append length in bits and transform
*/
for (i = 0, ii = 0; i < 14; i++, ii += 4)
in[i] = (((MD5UINT4) mdContext->in[ii + 3]) << 24) |
(((MD5UINT4) mdContext->in[ii + 2]) << 16) |
(((MD5UINT4) mdContext->in[ii + 1]) << 8) |
((MD5UINT4) mdContext->in[ii]);
SDLTest_Md5Transform(mdContext->buf, in);
/*
* store buffer in digest
*/
for (i = 0, ii = 0; i < 4; i++, ii += 4) {
mdContext->digest[ii] = (unsigned char) (mdContext->buf[i] & 0xFF);
mdContext->digest[ii + 1] =
(unsigned char) ((mdContext->buf[i] >> 8) & 0xFF);
mdContext->digest[ii + 2] =
(unsigned char) ((mdContext->buf[i] >> 16) & 0xFF);
mdContext->digest[ii + 3] =
(unsigned char) ((mdContext->buf[i] >> 24) & 0xFF);
}
}
SDLTest_Md5Context::i
MD5UINT4 i[2]
Definition: SDL_test_md5.h:72
MD5PADDING
static unsigned char MD5PADDING[64]
Definition: SDL_test_md5.c:61
SDLTest_Md5Context::in
unsigned char in[64]
Definition: SDL_test_md5.h:74
SDLTest_Md5Context::buf
MD5UINT4 buf[4]
Definition: SDL_test_md5.h:73
SDLTest_Md5Transform
static void SDLTest_Md5Transform(MD5UINT4 *buf, MD5UINT4 *in)
Definition: SDL_test_md5.c:232
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
NULL
#define NULL
Definition: begin_code.h:164
MD5UINT4
unsigned long int MD5UINT4
Definition: SDL_test_md5.h:68
SDLTest_Md5Update
void SDLTest_Md5Update(SDLTest_Md5Context *mdContext, unsigned char *inBuf, unsigned int inLen)
update digest from variable length data
Definition: SDL_test_md5.c:131
in
GLuint in
Definition: SDL_opengl_glext.h:7940
SDLTest_Md5Context::digest
unsigned char digest[16]
Definition: SDL_test_md5.h:75

## SDLTest_Md5Init()

void SDLTest_Md5Init | ( | SDLTest_Md5Context * | mdContext | ) |

initialize the context

Parameters

  mdContext | pointer to context variable

Note: The function initializes the message-digest context mdContext. Call before each new use of the context - all fields are set to zero.

Definition at line 110 of file SDL_test_md5.c.

References SDLTest_Md5Context::buf, SDLTest_Md5Context::i, and NULL.

Referenced by SDLTest_GenerateExecKey().

{
if (mdContext==NULL) return;
mdContext->i[0] = mdContext->i[1] = (MD5UINT4) 0;
/*
* Load magic initialization constants.
*/
mdContext->buf[0] = (MD5UINT4) 0x67452301;
mdContext->buf[1] = (MD5UINT4) 0xefcdab89;
mdContext->buf[2] = (MD5UINT4) 0x98badcfe;
mdContext->buf[3] = (MD5UINT4) 0x10325476;
}
SDLTest_Md5Context::i
MD5UINT4 i[2]
Definition: SDL_test_md5.h:72
SDLTest_Md5Context::buf
MD5UINT4 buf[4]
Definition: SDL_test_md5.h:73
NULL
#define NULL
Definition: begin_code.h:164
MD5UINT4
unsigned long int MD5UINT4
Definition: SDL_test_md5.h:68

## SDLTest_Md5Transform()

static void SDLTest_Md5Transform | ( | MD5UINT4 * | buf,
|  | MD5UINT4 * | in
| ) |  |

static

Definition at line 232 of file SDL_test_md5.c.

References d, FF, GG, HH, II, S11, S12, S13, S14, S21, S22, S23, S24, S31, S32, S33, S34, S41, S42, S43, and S44.

Referenced by SDLTest_Md5Final(), and SDLTest_Md5Update().

{
MD5UINT4 a = buf[0], b = buf[1], c = buf[2], d = buf[3];
/*
* Round 1
*/
#define S11 7
#define S12 12
#define S13 17
#define S14 22
FF(a, b, c, d, in[0], S11, 3614090360u); /* 1 */
FF(d, a, b, c, in[1], S12, 3905402710u); /* 2 */
FF(c, d, a, b, in[2], S13, 606105819u); /* 3 */
FF(b, c, d, a, in[3], S14, 3250441966u); /* 4 */
FF(a, b, c, d, in[4], S11, 4118548399u); /* 5 */
FF(d, a, b, c, in[5], S12, 1200080426u); /* 6 */
FF(c, d, a, b, in[6], S13, 2821735955u); /* 7 */
FF(b, c, d, a, in[7], S14, 4249261313u); /* 8 */
FF(a, b, c, d, in[8], S11, 1770035416u); /* 9 */
FF(d, a, b, c, in[9], S12, 2336552879u); /* 10 */
FF(c, d, a, b, in[10], S13, 4294925233u); /* 11 */
FF(b, c, d, a, in[11], S14, 2304563134u); /* 12 */
FF(a, b, c, d, in[12], S11, 1804603682u); /* 13 */
FF(d, a, b, c, in[13], S12, 4254626195u); /* 14 */
FF(c, d, a, b, in[14], S13, 2792965006u); /* 15 */
FF(b, c, d, a, in[15], S14, 1236535329u); /* 16 */
/*
* Round 2
*/
#define S21 5
#define S22 9
#define S23 14
#define S24 20
GG(a, b, c, d, in[1], S21, 4129170786u); /* 17 */
GG(d, a, b, c, in[6], S22, 3225465664u); /* 18 */
GG(c, d, a, b, in[11], S23, 643717713u); /* 19 */
GG(b, c, d, a, in[0], S24, 3921069994u); /* 20 */
GG(a, b, c, d, in[5], S21, 3593408605u); /* 21 */
GG(d, a, b, c, in[10], S22, 38016083u); /* 22 */
GG(c, d, a, b, in[15], S23, 3634488961u); /* 23 */
GG(b, c, d, a, in[4], S24, 3889429448u); /* 24 */
GG(a, b, c, d, in[9], S21, 568446438u); /* 25 */
GG(d, a, b, c, in[14], S22, 3275163606u); /* 26 */
GG(c, d, a, b, in[3], S23, 4107603335u); /* 27 */
GG(b, c, d, a, in[8], S24, 1163531501u); /* 28 */
GG(a, b, c, d, in[13], S21, 2850285829u); /* 29 */
GG(d, a, b, c, in[2], S22, 4243563512u); /* 30 */
GG(c, d, a, b, in[7], S23, 1735328473u); /* 31 */
GG(b, c, d, a, in[12], S24, 2368359562u); /* 32 */
/*
* Round 3
*/
#define S31 4
#define S32 11
#define S33 16
#define S34 23
HH(a, b, c, d, in[5], S31, 4294588738u); /* 33 */
HH(d, a, b, c, in[8], S32, 2272392833u); /* 34 */
HH(c, d, a, b, in[11], S33, 1839030562u); /* 35 */
HH(b, c, d, a, in[14], S34, 4259657740u); /* 36 */
HH(a, b, c, d, in[1], S31, 2763975236u); /* 37 */
HH(d, a, b, c, in[4], S32, 1272893353u); /* 38 */
HH(c, d, a, b, in[7], S33, 4139469664u); /* 39 */
HH(b, c, d, a, in[10], S34, 3200236656u); /* 40 */
HH(a, b, c, d, in[13], S31, 681279174u); /* 41 */
HH(d, a, b, c, in[0], S32, 3936430074u); /* 42 */
HH(c, d, a, b, in[3], S33, 3572445317u); /* 43 */
HH(b, c, d, a, in[6], S34, 76029189u); /* 44 */
HH(a, b, c, d, in[9], S31, 3654602809u); /* 45 */
HH(d, a, b, c, in[12], S32, 3873151461u); /* 46 */
HH(c, d, a, b, in[15], S33, 530742520u); /* 47 */
HH(b, c, d, a, in[2], S34, 3299628645u); /* 48 */
/*
* Round 4
*/
#define S41 6
#define S42 10
#define S43 15
#define S44 21
II(a, b, c, d, in[0], S41, 4096336452u); /* 49 */
II(d, a, b, c, in[7], S42, 1126891415u); /* 50 */
II(c, d, a, b, in[14], S43, 2878612391u); /* 51 */
II(b, c, d, a, in[5], S44, 4237533241u); /* 52 */
II(a, b, c, d, in[12], S41, 1700485571u); /* 53 */
II(d, a, b, c, in[3], S42, 2399980690u); /* 54 */
II(c, d, a, b, in[10], S43, 4293915773u); /* 55 */
II(b, c, d, a, in[1], S44, 2240044497u); /* 56 */
II(a, b, c, d, in[8], S41, 1873313359u); /* 57 */
II(d, a, b, c, in[15], S42, 4264355552u); /* 58 */
II(c, d, a, b, in[6], S43, 2734768916u); /* 59 */
II(b, c, d, a, in[13], S44, 1309151649u); /* 60 */
II(a, b, c, d, in[4], S41, 4149444226u); /* 61 */
II(d, a, b, c, in[11], S42, 3174756917u); /* 62 */
II(c, d, a, b, in[2], S43, 718787259u); /* 63 */
II(b, c, d, a, in[9], S44, 3951481745u); /* 64 */
buf[0] += a;
buf[1] += b;
buf[2] += c;
buf[3] += d;
}
S32
#define S32
S42
#define S42
HH
#define HH(a, b, c, d, x, s, ac)
Definition: SDL_test_md5.c:94
S23
#define S23
S22
#define S22
II
#define II(a, b, c, d, x, s, ac)
Definition: SDL_test_md5.c:99
d
SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char const char SDL_SCANF_FORMAT_STRING const char return SDL_ThreadFunction const char void return Uint32 return Uint32 SDL_AssertionHandler void SDL_SpinLock SDL_atomic_t int int return SDL_atomic_t return void void void return void return int return SDL_AudioSpec SDL_AudioSpec return int int return return int SDL_RWops int SDL_AudioSpec Uint8 ** d
Definition: SDL_dynapi_procs.h:117
S41
#define S41
GG
#define GG(a, b, c, d, x, s, ac)
Definition: SDL_test_md5.c:89
c
const GLubyte * c
Definition: SDL_opengl_glext.h:11093
S24
#define S24
FF
#define FF(a, b, c, d, x, s, ac)
Definition: SDL_test_md5.c:84
buf
GLenum GLuint GLenum GLsizei const GLchar * buf
Definition: SDL_opengl_glext.h:2480
S14
#define S14
S12
#define S12
S31
#define S31
MD5UINT4
unsigned long int MD5UINT4
Definition: SDL_test_md5.h:68
S43
#define S43
S44
#define S44
S11
#define S11
S21
#define S21
S13
#define S13
S34
#define S34
a
GLboolean GLboolean GLboolean GLboolean a
Definition: SDL_opengl_glext.h:1109
in
GLuint in
Definition: SDL_opengl_glext.h:7940
b
GLboolean GLboolean GLboolean b
Definition: SDL_opengl_glext.h:1109
S33
#define S33

## SDLTest_Md5Update()

void SDLTest_Md5Update | ( | SDLTest_Md5Context * | mdContext,
|  | unsigned char * | inBuf,
|  | unsigned int | inLen
| ) |  |

update digest from variable length data

Parameters

  mdContext | pointer to context variable
  inBuf | pointer to data array/string
  inLen | length of data array/string

Note: The function updates the message-digest context to account for the presence of each of the characters inBuf[0..inLen-1] in the message whose digest is being computed.

Definition at line 131 of file SDL_test_md5.c.

References SDLTest_Md5Context::buf, i, SDLTest_Md5Context::i, SDLTest_Md5Context::in, NULL, and SDLTest_Md5Transform().

Referenced by SDLTest_GenerateExecKey(), and SDLTest_Md5Final().

{
MD5UINT4 in[16];
int mdi;
unsigned int i, ii;
if (mdContext == NULL) return;
if (inBuf == NULL || inLen < 1) return;
/*
* compute number of bytes mod 64
*/
mdi = (int) ((mdContext->i[0] >> 3) & 0x3F);
/*
* update number of bits
*/
if ((mdContext->i[0] + ((MD5UINT4) inLen << 3)) < mdContext->i[0])
mdContext->i[1]++;
mdContext->i[0] += ((MD5UINT4) inLen << 3);
mdContext->i[1] += ((MD5UINT4) inLen >> 29);
while (inLen--) {
/*
* add new character to buffer, increment mdi
*/
mdContext->in[mdi++] = *inBuf++;
/*
* transform if necessary
*/
if (mdi == 0x40) {
for (i = 0, ii = 0; i < 16; i++, ii += 4)
in[i] = (((MD5UINT4) mdContext->in[ii + 3]) << 24) |
(((MD5UINT4) mdContext->in[ii + 2]) << 16) |
(((MD5UINT4) mdContext->in[ii + 1]) << 8) |
((MD5UINT4) mdContext->in[ii]);
SDLTest_Md5Transform(mdContext->buf, in);
mdi = 0;
}
}
}
SDLTest_Md5Context::i
MD5UINT4 i[2]
Definition: SDL_test_md5.h:72
SDLTest_Md5Context::in
unsigned char in[64]
Definition: SDL_test_md5.h:74
SDLTest_Md5Context::buf
MD5UINT4 buf[4]
Definition: SDL_test_md5.h:73
SDLTest_Md5Transform
static void SDLTest_Md5Transform(MD5UINT4 *buf, MD5UINT4 *in)
Definition: SDL_test_md5.c:232
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
NULL
#define NULL
Definition: begin_code.h:164
MD5UINT4
unsigned long int MD5UINT4
Definition: SDL_test_md5.h:68
in
GLuint in
Definition: SDL_opengl_glext.h:7940

## Variable Documentation

## MD5PADDING

unsigned char MD5PADDING[64]

static

Initial value:
= {
0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
}

Definition at line 61 of file SDL_test_md5.c.

Referenced by SDLTest_Md5Final().